package com.ruoyi.web.controller.dingding.service;

import com.alibaba.fastjson.JSONObject;
import com.dingtalk.api.response.OapiV2UserGetResponse;
import com.ruoyi.common.core.domain.entity.SysUser;

import java.util.Map;

/**
 * <p>DingAuthService 此接口用于：</p>
 * <p>@remark：</p>
 */
public interface DingAuthServiceInfo {

    /**
     * 根据用户手机号查询是否是公司员工
     *
     * @param userId 钉钉用户id
     * @return UIOT员工信息
     */
    SysUser getUserByUserId(String userId);


    /**
     * 根据用户手机号查询是否是公司员工
     *
     * @param mobile 钉钉用户手机号
     * @return UIOT员工信息
     */
    SysUser getUserByUsername(String mobile);

    SysUser addUserAndOrg(OapiV2UserGetResponse response);

    SysUser initUser(OapiV2UserGetResponse.UserGetResponse response, String corpId);

    String decryptText(String signature, String timestamp, String nonce, String encryptMsg);

    Map<String, String> caseProcess(JSONObject plainNode);

    Map<String, String> encryptText(String text);


}