package com.ruoyi.common.utils.moonshot;

import cn.moonshot.platform.util.MoonshotAiUtils;
import com.ruoyi.common.enums.ChatMessageRole;
import com.ruoyi.common.utils.moonshot.vo.ChatCompletionMessage;
import com.ruoyi.common.utils.moonshot.vo.ChatCompletionRequest;
import com.ruoyi.common.utils.moonshot.vo.ChatCompletionStreamChoice;
import com.ruoyi.common.utils.moonshot.vo.FileUploadResult;

import java.io.File;
import java.io.IOException;
import java.util.Arrays;
import java.util.List;

public class MoonshotDemoMain {

    public static void main(String... args) throws IOException {

        String apiKey = "sk-6RRz9mTfCnit49IQwpxs3oa2JHqfOVuQvWDy3HauX2CExvwg";
        if (apiKey == null) {
            System.out.println("Please set MOONSHOT_API_KEY env");
            return;
        }
        Client client = new Client(apiKey);

        File file = new File("/D:/szty/695b2905-dda7-4e7d-b321-641ea3b06c74.pdf");
        FileUploadResult resuat = client.uploadFile(file);
        if(null != resuat.getError()){

        }else if(resuat.getStatus().equals("ok")) {
            String fileId = resuat.getId();
            System.out.println(resuat);
            String fileContent = MoonshotAiUtils.getFileContent(fileId,client.getApiKey());
            System.out.println(fileContent);

            MoonshotAiUtils.deleteFile(fileId,client.getApiKey());

            final List<ChatCompletionMessage> messages = Arrays.asList(
                    new ChatCompletionMessage(ChatMessageRole.SYSTEM.value(),
                            "你是简历整理AI,同个标准格式生成简历统一的简历相信内容.简历格式如下"),
                    new ChatCompletionMessage(ChatMessageRole.SYSTEM.value(),
                            "基本信息\n" +
                                    "\n" +
                                    "姓名：[你的全名]\n" +
                                    "联系方式：\n" +
                                    "年龄：[你的年龄]\n" +
                                    "电话：[你的电话号码]\n" +
                                    "邮箱：[你的电子邮箱地址]\n" +
                                    "地址：[你的居住地址]\n" +
                                    "工作年限：[你的工作时间经验]\n" +
                                    "链接：\n" +
                                    "LinkedIn：[你的LinkedIn个人资料链接]\n" +
                                    "个人网站/博客：[如果有，提供个人网站或博客链接]\n" +
                                    "个人简介\n" +
                                    "\n" +
                                    "简短介绍自己的职业目标和核心技能。\n" +
                                    "教育背景\n" +
                                    "\n" +
                                    "学位：[学位名称]\n" +
                                    "专业：[专业名称]\n" +
                                    "学校：[学校名称]\n" +
                                    "毕业时间：[毕业年份]\n" +
                                    "工作经验\n" +
                                    "\n" +
                                    "[公司名称]\n" +
                                    "[职位名称]\n" +
                                    "工作时间：[开始时间] - [结束时间]\n" +
                                    "工作职责：\n" +
                                    "职责1\n" +
                                    "职责2\n" +
                                    "...\n" +
                                    "技能\n" +
                                    "\n" +
                                    "列出与职位相关的专业技能，例如编程语言、软件操作、外语能力等。\n" +
                                    "项目经验\n" +
                                    "\n" +
                                    "[项目名称]\n" +
                                    "项目描述：[简短介绍项目内容]\n" +
                                    "角色：[你在项目中的角色]\n" +
                                    "主要贡献：[你在项目中的主要贡献]\n" +
                                    "使用技术：[项目中使用的技术或工具]\n" +
                                    "荣誉和奖项\n" +
                                    "\n" +
                                    "[奖项名称] - [颁发机构] - [颁发时间]\n" +
                                    "证书\n" +
                                    "\n" +
                                    "[证书名称] - [颁发机构] - [获得时间]\n" +
                                    "语言能力\n" +
                                    "\n" +
                                    "[语言] - [熟练程度]\n" +
                                    "兴趣爱好\n" +
                                    "\n" +
                                    "简要介绍你的个人兴趣或爱好。\n" +
                                    "其他\n" +
                                    "\n" +
                                    "任何其他可能对求职有帮助的信息。"),
                    new ChatCompletionMessage(ChatMessageRole.SYSTEM.value(),
                            fileContent),
                    new ChatCompletionMessage(ChatMessageRole.USER.value(),
                            "请整理简历内容，并按照标准格式返回")
            );

//        try {
//            ChatCompletionResponse response = client.ChatCompletion(new ChatCompletionRequest(
//                    "moonshot-v1-8k",
//                    messages,
//                    50,
//                    0.3f,
//                    1
//            ));
//            for (ChatCompletionChoice choice : response.getChoices()) {
//                System.out.println(choice.getMessage().getContent());
//            }
//        } catch (IOException e) {
//            e.printStackTrace();
//        }

            StringBuilder str = new StringBuilder();

            try {
                client.ChatCompletionStream(new ChatCompletionRequest(
                        "moonshot-v1-128k",
                        messages,
                        8196,
                        0.3f,
                        1
                )).subscribe(
                        streamResponse -> {
                            if (streamResponse.getChoices().isEmpty()) {
                                return;
                            }
                            for (ChatCompletionStreamChoice choice : streamResponse.getChoices()) {
                                String finishReason = choice.getFinishReason();
                                if (finishReason != null) {
                                    continue;
                                }
                                // 将每个choice的delta内容添加到StringBuilder中
                                str.append(choice.getDelta().getContent());
                            }
                        },
                        error -> {
                            error.printStackTrace();
                        },
                        () -> {
                            System.out.println(str);
                            // todo 格式解析完成-存储简历内容整理并返回
                            //处理标识分段，并判断内容情况

                        }
                );
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }


}
