package com.ruoyi.common.utils.moonshot.vo;

import com.google.gson.annotations.SerializedName;
import com.ruoyi.common.enums.ChatMessageRole;

import java.util.Arrays;
import java.util.List;

public class ChatCompletionRequest {
    public String model;
    public List<ChatCompletionMessage> messages;

    @SerializedName("max_tokens")
    public int maxTokens;

    @SerializedName("temperature")
    public float temperature;
    public float topP;

    public Integer n;
    public boolean stream;
    public List<String> stop;

    @SerializedName("presence_penalty")
    public float presencePenalty;

    @SerializedName("frequency_penalty")
    public float frequencyPenalty;

    public String user;

    public List<ChatCompletionMessage> getMessages() {
        return messages;
    }

    public ChatCompletionRequest(String model, List<ChatCompletionMessage> messages, int maxTokens, float temperature, int n) {
        this.model = model;
        this.messages = messages;
        this.maxTokens = maxTokens;
        this.temperature = temperature;
        this.n = n;
    }

    public ChatCompletionRequest(String fileContent){
        List<ChatCompletionMessage> messages = Arrays.asList(
                new ChatCompletionMessage(ChatMessageRole.SYSTEM.value(),
                        "你是简历整理AI,同个标准格式生成简历统一的简历详细内容.简历格式如下"),
                new ChatCompletionMessage(ChatMessageRole.SYSTEM.value(),
                        "{\n" +
                                "  \"resume\": {\n" +
                                "    \"userName\": \"你的全名\",\n" +
                                "    \"gender\": \"你的性别\",\n" +
                                "    \"age\": \"你的年龄\",\n" +
                                "    \"degree\": \"你的学历\",\n" +
                                "    \"mobile\": \"你的电话号码\",\n" +
                                "    \"email\": \"你的电子邮箱地址\",\n" +
                                "    \"address\": \"你的居住地址\"\n" +
                                "  },\n" +
                                "  \"selfIntroduce\": \"简短介绍自己的职业目标和核心技能。\",\n" +
                                "  \"eduList\": [\n" +
                                "    {\n" +
                                "      \"degree\": \"学位名称\",\n" +
                                "      \"major\": \"专业名称\",\n" +
                                "      \"schoolName\": \"学校名称\",\n" +
                                "      \"graduationYear\": \"毕业年份\"\n" +
                                "    }\n" +
                                "  ],\n" +
                                "  \"workList\": [\n" +
                                "    {\n" +
                                "      \"companyName\": \"公司名称\",\n" +
                                "      \"postionName\": \"职位名称\",\n" +
                                "      \"iinductionStartDate\": \"开始时间\",\n" +
                                "      \"iinductionEndDate\": \"结束时间\",\n" +
                                "      \"workDetail\": \"职责\"\n" +
                                "    }\n" +
                                "  ],\n" +
                                "  \"keyWords\": \"与职位相关的专业技能1\",\n" +
                                "  \"projectList\": [\n" +
                                "    {\n" +
                                "      \"projectName\": \"项目名称\",\n" +
                                "      \"projectDetail\": \"简短介绍项目内容\",\n" +
                                "      \"partIn\": \"你在项目中的角色\",\n" +
                                "      \"contributions\": \"主要贡献\",\n" +
                                "      \"developTools\": \"使用技术或工具\"\n" +
                                "    }\n" +
                                "  ],\n" +
                                "  \"certificate\": \"name\": \"获得证书信息\",\n" +
                                "  \"languageAbility\": \"language\": \"语言能力\",\n" +
                                "  \"selfEvaluation\": \"简要介绍你的个人兴趣或爱好。\",\n" +
                                "  \"otherInformation\": \"任何其他可能对求职有帮助的信息。\"\n" +
                                "}"),
                new ChatCompletionMessage(ChatMessageRole.SYSTEM.value(),
                        fileContent),
                new ChatCompletionMessage(ChatMessageRole.USER.value(),
                        "请整理简历内容，并按照标准格式返回")
        );

        this.model = "moonshot-v1-128k";
        this.messages = messages;
        this.maxTokens = 8196;
        this.temperature = 0.3f;
        this.n = 1;

    }



}
