package com.ruoyi.system.domain.resume;

import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

/**
 * 公司基本信息管理对象 company_info
 * 
 * @author ruoyi
 * @date 2024-02-21
 */
public class CompanyInfo extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** Id */
    private Long id;

    /** 公司标识 */
    @Excel(name = "公司标识")
    private String companyId;

    /** 公司全称 */
    @Excel(name = "公司全称")
    private String companyFullName;

    /** 显示名称 */
    @Excel(name = "显示名称")
    private String companyName;

    /** 英文全称 */
    @Excel(name = "英文全称")
    private String companyFullNameEn;

    /** 所在地 */
    @Excel(name = "所在地")
    private String address;

    /** 所属行业 */
    @Excel(name = "所属行业")
    private String industryId;

    /** Logo图片 */
    @Excel(name = "Logo图片")
    private String logoPath;

    /** 二级域名 */
    @Excel(name = "二级域名")
    private String SLD;

    /** 钉钉用户所属的组织的企业corpId */
    @Excel(name = "钉钉用户所属的组织的企业corpId")
    private String corpId;

    /** 创建时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "创建时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date createDate;

    /** 创建者 */
    @Excel(name = "创建者")
    private String createUserId;

    /** 最后一次更新时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "最后一次更新时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date updateDate;

    /** 是否已删除;0-未删除;1-已删除 */
    @Excel(name = "是否已删除;0-未删除;1-已删除")
    private String isDelete;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    private String adminUser;

    public void setId(Long id) 
    {
        this.id = id;
    }

    public Long getId() 
    {
        return id;
    }
    public void setCompanyId(String companyId) 
    {
        this.companyId = companyId;
    }

    public String getCompanyId() 
    {
        return companyId;
    }
    public void setCompanyFullName(String companyFullName) 
    {
        this.companyFullName = companyFullName;
    }

    public String getCompanyFullName() 
    {
        return companyFullName;
    }
    public void setCompanyName(String companyName) 
    {
        this.companyName = companyName;
    }

    public String getCompanyName() 
    {
        return companyName;
    }
    public void setCompanyFullNameEn(String companyFullNameEn) 
    {
        this.companyFullNameEn = companyFullNameEn;
    }

    public String getCompanyFullNameEn() 
    {
        return companyFullNameEn;
    }
    public void setAddress(String address) 
    {
        this.address = address;
    }

    public String getAddress() 
    {
        return address;
    }
    public void setIndustryId(String industryId) 
    {
        this.industryId = industryId;
    }

    public String getIndustryId() 
    {
        return industryId;
    }
    public void setLogoPath(String logoPath) 
    {
        this.logoPath = logoPath;
    }

    public String getLogoPath() 
    {
        return logoPath;
    }
    public void setSLD(String SLD) 
    {
        this.SLD = SLD;
    }

    public String getSLD() 
    {
        return SLD;
    }
    public void setCorpId(String corpId) 
    {
        this.corpId = corpId;
    }

    public String getCorpId() 
    {
        return corpId;
    }
    public void setCreateDate(Date createDate) 
    {
        this.createDate = createDate;
    }

    public Date getCreateDate() 
    {
        return createDate;
    }
    public void setCreateUserId(String createUserId) 
    {
        this.createUserId = createUserId;
    }

    public String getCreateUserId() 
    {
        return createUserId;
    }
    public void setUpdateDate(Date updateDate) 
    {
        this.updateDate = updateDate;
    }

    public Date getUpdateDate() 
    {
        return updateDate;
    }
    public void setIsDelete(String isDelete) 
    {
        this.isDelete = isDelete;
    }

    public String getIsDelete() 
    {
        return isDelete;
    }
    public void setAdminUser(String adminUser) 
    {
        this.adminUser = adminUser;
    }

    public String getAdminUser() 
    {
        return adminUser;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this,ToStringStyle.MULTI_LINE_STYLE)
            .append("id", getId())
            .append("companyId", getCompanyId())
            .append("companyFullName", getCompanyFullName())
            .append("companyName", getCompanyName())
            .append("companyFullNameEn", getCompanyFullNameEn())
            .append("address", getAddress())
            .append("industryId", getIndustryId())
            .append("logoPath", getLogoPath())
            .append("SLD", getSLD())
            .append("corpId", getCorpId())
            .append("createDate", getCreateDate())
            .append("createUserId", getCreateUserId())
            .append("updateDate", getUpdateDate())
            .append("isDelete", getIsDelete())
            .append("adminUser", getAdminUser())
            .toString();
    }
}
