package com.ruoyi.system.mapper.crm;

import com.ruoyi.system.domain.crm.TCustomer;

import java.util.List;
/**
 * crmMapper接口
 * 
 * @author ruoyi
 * @date 2023-11-28
 */
public interface TCustomerMapper 
{
    /**
     * 查询crm
     * 
     * @param id crm主键
     * @return crm
     */
    public TCustomer selectTCustomerById(String id);

    /**
     * 查询crm列表
     * 
     * @param tCustomer crm
     * @return crm集合
     */
    public List<TCustomer> selectTCustomerList(TCustomer tCustomer);

    /**
     * 新增crm
     * 
     * @param tCustomer crm
     * @return 结果
     */
    public int insertTCustomer(TCustomer tCustomer);

    /**
     * 修改crm
     * 
     * @param tCustomer crm
     * @return 结果
     */
    public int updateTCustomer(TCustomer tCustomer);

    /**
     * 删除crm
     * 
     * @param id crm主键
     * @return 结果
     */
    public int deleteTCustomerById(String id);

    /**
     * 批量删除crm
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTCustomerByIds(String[] ids);
}
