package com.ruoyi.system.mapper.dhrm;

import com.ruoyi.system.domain.dhrm.DhrmCompany;

import java.util.List;

/**
 * 公司管理Mapper接口
 * 
 * @author ruoyi
 * @date 2023-11-16
 */
public interface DhrmCompanyMapper 
{
    /**
     * 查询公司管理
     * 
     * @param dhrmId 公司管理主键
     * @return 公司管理
     */
    public DhrmCompany selectDhrmCompanyByDhrmId(Long dhrmId);

    /**
     * 查询公司管理列表
     * 
     * @param dhrmCompany 公司管理
     * @return 公司管理集合
     */
    public List<DhrmCompany> selectDhrmCompanyList(DhrmCompany dhrmCompany);

    /**
     * 新增公司管理
     * 
     * @param dhrmCompany 公司管理
     * @return 结果
     */
    public int insertDhrmCompany(DhrmCompany dhrmCompany);

    /**
     * 修改公司管理
     * 
     * @param dhrmCompany 公司管理
     * @return 结果
     */
    public int updateDhrmCompany(DhrmCompany dhrmCompany);

    /**
     * 删除公司管理
     * 
     * @param dhrmId 公司管理主键
     * @return 结果
     */
    public int deleteDhrmCompanyByDhrmId(Long dhrmId);

    /**
     * 批量删除公司管理
     * 
     * @param dhrmIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteDhrmCompanyByDhrmIds(Long[] dhrmIds);

    /**
     * 根据员工编号查询公司数据
     *
     * @param employNo
     * @return
     */
    public DhrmCompany selectDhrmCompanyByEmployNo(String employNo);
}
