package com.ruoyi.system.mapper.resume;

import com.ruoyi.system.domain.resume.ResumeProject;

import java.util.List;

/**
 * 简历项目信息管理Mapper接口
 * 
 * @author ruoyi
 * @date 2024-02-21
 */
public interface ResumeProjectMapper 
{
    /**
     * 查询简历项目信息管理
     * 
     * @param projectId 简历项目信息管理主键
     * @return 简历项目信息管理
     */
    public ResumeProject selectResumeProjectByProjectId(Long projectId);

    /**
     * 查询简历项目信息管理列表
     * 
     * @param resumeProject 简历项目信息管理
     * @return 简历项目信息管理集合
     */
    public List<ResumeProject> selectResumeProjectList(ResumeProject resumeProject);

    /**
     * 新增简历项目信息管理
     * 
     * @param resumeProject 简历项目信息管理
     * @return 结果
     */
    public int insertResumeProject(ResumeProject resumeProject);

    /**
     * 修改简历项目信息管理
     * 
     * @param resumeProject 简历项目信息管理
     * @return 结果
     */
    public int updateResumeProject(ResumeProject resumeProject);

    /**
     * 删除简历项目信息管理
     * 
     * @param projectId 简历项目信息管理主键
     * @return 结果
     */
    public int deleteResumeProjectByProjectId(Long projectId);

    /**
     * 批量删除简历项目信息管理
     * 
     * @param projectIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteResumeProjectByProjectIds(Long[] projectIds);

    /**
     * 根据简历ID删除简历项目经验信息
     *
     * @param resumeId
     * @return
     */
    int deleteResumeProjectByResumeId(Long resumeId);
}
