package com.ruoyi.system.service.crm;

import com.ruoyi.system.domain.crm.Contacts;

import java.util.List;

/**
 * 客户联系人信息Service接口
 * 
 * @author ruoyi
 * @date 2023-11-15
 */
public interface IContactsService 
{
    /**
     * 查询客户联系人信息
     * 
     * @param id 客户联系人信息主键
     * @return 客户联系人信息
     */
    public Contacts selectContactsById(Long id);

    /**
     * 查询客户联系人信息列表
     * 
     * @param contacts 客户联系人信息
     * @return 客户联系人信息集合
     */
    public List<Contacts> selectContactsList(Contacts contacts);

    /**
     * 新增客户联系人信息
     * 
     * @param contacts 客户联系人信息
     * @return 结果
     */
    public int insertContacts(Contacts contacts);

    /**
     * 修改客户联系人信息
     * 
     * @param contacts 客户联系人信息
     * @return 结果
     */
    public int updateContacts(Contacts contacts);

    /**
     * 批量删除客户联系人信息
     * 
     * @param ids 需要删除的客户联系人信息主键集合
     * @return 结果
     */
    public int deleteContactsByIds(Long[] ids);

    /**
     * 删除客户联系人信息信息
     * 
     * @param id 客户联系人信息主键
     * @return 结果
     */
    public int deleteContactsById(Long id);


    /**
     * 批量新增客户联系人信息
     * @param contactsList
     */
    public int batchInsertContacts(List<Contacts> contactsList);


}
