package com.ruoyi.system.service.crm;

import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.system.domain.crm.Customer;

import java.util.List;

/**
 * CRM系统Service接口
 * 
 * @author ruoyi
 * @date 2023-11-15
 */
public interface ICustomerService 
{
    /**
     * 查询CRM系统
     * 
     * @param id CRM系统主键
     * @return CRM系统
     */
    public Customer selectCustomerById(Long id);

    /**
     * 查询CRM系统列表
     * 
     * @param customer CRM系统
     * @return CRM系统集合
     */
    public List<Customer> selectCustomerList(Customer customer);

    /**
     * 新增CRM系统
     * 
     * @param customer CRM系统
     * @return 结果
     */
    public int insertCustomer(Customer customer);

    /**
     * 修改CRM系统
     * 
     * @param customer CRM系统
     * @return 结果
     */
    public int updateCustomer(Customer customer);

    /**
     * 批量删除CRM系统
     * 
     * @param ids 需要删除的CRM系统主键集合
     * @return 结果
     */
    public int deleteCustomerByIds(Long[] ids);

    /**
     * 删除CRM系统信息
     * 
     * @param id CRM系统主键
     * @return 结果
     */
    public int deleteCustomerById(Long id);

    /**
     * 我的待办任务
     * @param customer
     * @return
     */
    List<Customer> myTaskList(Customer customer);


}
