package com.ruoyi.system.service.crm.impl;

import java.util.List;

import com.ruoyi.common.annotation.DataScope;
import com.ruoyi.system.domain.crm.Customer;
import com.ruoyi.system.mapper.crm.CustomerMapper;
import com.ruoyi.system.service.crm.ICustomerService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * CRM系统Service业务层处理
 * 
 * @author ruoyi
 * @date 2023-11-15
 */
@Service
public class CustomerServiceImpl implements ICustomerService
{
    @Autowired
    private CustomerMapper customerMapper;

    /**
     * 查询CRM系统
     * 
     * @param id CRM系统主键
     * @return CRM系统
     */
    @Override
    public Customer selectCustomerById(Long id)
    {
        return customerMapper.selectCustomerById(id);
    }

    /**
     * 查询CRM系统列表
     * 
     * @param customer CRM系统
     * @return CRM系统
     */
    @Override
    @DataScope(deptAlias = "d", userAlias = "u")
    public List<Customer> selectCustomerList(Customer customer)
    {
        return customerMapper.selectCustomerList(customer);
    }

    /**
     * 新增CRM系统
     * 
     * @param customer CRM系统
     * @return 结果
     */
    @Override
    public int insertCustomer(Customer customer)
    {
        return customerMapper.insertCustomer(customer);
    }

    /**
     * 修改CRM系统
     * 
     * @param customer CRM系统
     * @return 结果
     */
    @Override
    public int updateCustomer(Customer customer)
    {
        return customerMapper.updateCustomer(customer);
    }

    /**
     * 批量删除CRM系统
     * 
     * @param ids 需要删除的CRM系统主键
     * @return 结果
     */
    @Override
    public int deleteCustomerByIds(Long[] ids)
    {
        return customerMapper.deleteCustomerByIds(ids);
    }

    /**
     * 删除CRM系统信息
     * 
     * @param id CRM系统主键
     * @return 结果
     */
    @Override
    public int deleteCustomerById(Long id)
    {
        return customerMapper.deleteCustomerById(id);
    }

    @Override
    @DataScope(deptAlias = "d", userAlias = "u")
    public List<Customer> myTaskList(Customer customer) {
        return customerMapper.myTaskList(customer);
    }
}
