package com.ruoyi.system.service.dhrm.impl;

import java.util.List;

import com.ruoyi.system.domain.dhrm.DhrmCompany;
import com.ruoyi.system.mapper.dhrm.DhrmCompanyMapper;
import com.ruoyi.system.service.dhrm.IDhrmCompanyService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 公司管理Service业务层处理
 * 
 * @author ruoyi
 * @date 2023-11-16
 */
@Service
public class DhrmCompanyServiceImpl implements IDhrmCompanyService
{
    @Autowired
    private DhrmCompanyMapper dhrmCompanyMapper;

    /**
     * 查询公司管理
     * 
     * @param dhrmId 公司管理主键
     * @return 公司管理
     */
    @Override
    public DhrmCompany selectDhrmCompanyByDhrmId(Long dhrmId)
    {
        return dhrmCompanyMapper.selectDhrmCompanyByDhrmId(dhrmId);
    }

    /**
     * 查询公司管理列表
     * 
     * @param dhrmCompany 公司管理
     * @return 公司管理
     */
    @Override
    public List<DhrmCompany> selectDhrmCompanyList(DhrmCompany dhrmCompany)
    {
        return dhrmCompanyMapper.selectDhrmCompanyList(dhrmCompany);
    }

    /**
     * 新增公司管理
     * 
     * @param dhrmCompany 公司管理
     * @return 结果
     */
    @Override
    public int insertDhrmCompany(DhrmCompany dhrmCompany)
    {
        return dhrmCompanyMapper.insertDhrmCompany(dhrmCompany);
    }

    /**
     * 修改公司管理
     * 
     * @param dhrmCompany 公司管理
     * @return 结果
     */
    @Override
    public int updateDhrmCompany(DhrmCompany dhrmCompany)
    {
        return dhrmCompanyMapper.updateDhrmCompany(dhrmCompany);
    }

    /**
     * 批量删除公司管理
     * 
     * @param dhrmIds 需要删除的公司管理主键
     * @return 结果
     */
    @Override
    public int deleteDhrmCompanyByDhrmIds(Long[] dhrmIds)
    {
        return dhrmCompanyMapper.deleteDhrmCompanyByDhrmIds(dhrmIds);
    }

    /**
     * 删除公司管理信息
     * 
     * @param dhrmId 公司管理主键
     * @return 结果
     */
    @Override
    public int deleteDhrmCompanyByDhrmId(Long dhrmId)
    {
        return dhrmCompanyMapper.deleteDhrmCompanyByDhrmId(dhrmId);
    }

    /**
     *
     * 根据员工编号查询公司数据
     * @param employNo
     * @return
     */
    @Override
    public DhrmCompany selectDhrmCompanyByEmployNo(String employNo) {
        return dhrmCompanyMapper.selectDhrmCompanyByEmployNo(employNo);
    }
}
