package com.ruoyi.system.service.resume;

import com.ruoyi.system.domain.resume.CompanyInfo;

import java.util.List;

/**
 * 公司基本信息管理Service接口
 * 
 * @author ruoyi
 * @date 2024-02-21
 */
public interface ICompanyInfoService 
{
    /**
     * 查询公司基本信息管理
     * 
     * @param id 公司基本信息管理主键
     * @return 公司基本信息管理
     */
    public CompanyInfo selectCompanyInfoById(Long id);

    /**
     * 查询公司基本信息管理列表
     * 
     * @param companyInfo 公司基本信息管理
     * @return 公司基本信息管理集合
     */
    public List<CompanyInfo> selectCompanyInfoList(CompanyInfo companyInfo);

    /**
     * 新增公司基本信息管理
     * 
     * @param companyInfo 公司基本信息管理
     * @return 结果
     */
    public int insertCompanyInfo(CompanyInfo companyInfo);

    /**
     * 修改公司基本信息管理
     * 
     * @param companyInfo 公司基本信息管理
     * @return 结果
     */
    public int updateCompanyInfo(CompanyInfo companyInfo);

    /**
     * 批量删除公司基本信息管理
     * 
     * @param ids 需要删除的公司基本信息管理主键集合
     * @return 结果
     */
    public int deleteCompanyInfoByIds(Long[] ids);

    /**
     * 删除公司基本信息管理信息
     * 
     * @param id 公司基本信息管理主键
     * @return 结果
     */
    public int deleteCompanyInfoById(Long id);
}
