package com.ruoyi.system.service.resume;

import com.ruoyi.system.domain.resume.ResumeFile;

import java.util.List;

/**
 * 简历附件管理Service接口
 * 
 * @author ruoyi
 * @date 2024-02-19
 */
public interface IResumeFileService 
{
    /**
     * 查询简历附件管理
     * 
     * @param id 简历附件管理主键
     * @return 简历附件管理
     */
    public ResumeFile selectResumeFileById(Long id);

    /**
     * 查询简历附件管理列表
     * 
     * @param resumeFile 简历附件管理
     * @return 简历附件管理集合
     */
    public List<ResumeFile> selectResumeFileList(ResumeFile resumeFile);

    /**
     * 新增简历附件管理
     * 
     * @param resumeFile 简历附件管理
     * @return 结果
     */
    public int insertResumeFile(ResumeFile resumeFile);

    /**
     * 修改简历附件管理
     * 
     * @param resumeFile 简历附件管理
     * @return 结果
     */
    public int updateResumeFile(ResumeFile resumeFile);

    /**
     * 批量删除简历附件管理
     * 
     * @param ids 需要删除的简历附件管理主键集合
     * @return 结果
     */
    public int deleteResumeFileByIds(Long[] ids);

    /**
     * 删除简历附件管理信息
     * 
     * @param id 简历附件管理主键
     * @return 结果
     */
    public int deleteResumeFileById(Long id);

    /**
     * 删除简历附件管理信息
     *
     * @param resumeId 简历管理主键
     * @return 结果
     */
    public int deleteResumeFileByResumeId(Long resumeId);
}
