package com.ruoyi.system.service.resume;

import com.ruoyi.system.domain.resume.Resume;

import java.util.List;

/**
 * 简历管理Service接口
 * 
 * @author ruoyi
 * @date 2024-02-18
 */
public interface IResumeService 
{
    /**
     * 查询简历管理
     * 
     * @param resumeId 简历管理主键
     * @return 简历管理
     */
    public Resume selectResumeByResumeId(Long resumeId,String corpId);

    /**
     * 查询简历管理列表
     * 
     * @param resume 简历管理
     * @return 简历管理集合
     */
    public List<Resume> selectResumeList(Resume resume);

    /**
     * 新增简历管理
     * 
     * @param resume 简历管理
     * @return 结果
     */
    public int insertResume(Resume resume);

    /**
     * 修改简历管理
     * 
     * @param resume 简历管理
     * @return 结果
     */
    public int updateResume(Resume resume);

    /**
     * 批量删除简历管理
     * 
     * @param resumeIds 需要删除的简历管理主键集合
     * @return 结果
     */
    public int deleteResumeByResumeIds(Long[] resumeIds);

    /**
     * 删除简历管理信息
     * 
     * @param resumeId 简历管理主键
     * @return 结果
     */
    public int deleteResumeByResumeId(Long resumeId);
}
