package com.ruoyi.system.service.resume;

import com.ruoyi.system.domain.resume.ResumeWork;

import java.util.List;

/**
 * 简历工作经历信息管理Service接口
 * 
 * @author ruoyi
 * @date 2024-02-21
 */
public interface IResumeWorkService 
{
    /**
     * 查询简历工作经历信息管理
     * 
     * @param workId 简历工作经历信息管理主键
     * @return 简历工作经历信息管理
     */
    public ResumeWork selectResumeWorkByWorkId(Long workId);

    /**
     * 查询简历工作经历信息管理列表
     * 
     * @param resumeWork 简历工作经历信息管理
     * @return 简历工作经历信息管理集合
     */
    public List<ResumeWork> selectResumeWorkList(ResumeWork resumeWork);

    /**
     * 新增简历工作经历信息管理
     * 
     * @param resumeWork 简历工作经历信息管理
     * @return 结果
     */
    public int insertResumeWork(ResumeWork resumeWork);

    /**
     * 修改简历工作经历信息管理
     * 
     * @param resumeWork 简历工作经历信息管理
     * @return 结果
     */
    public int updateResumeWork(ResumeWork resumeWork);

    /**
     * 批量删除简历工作经历信息管理
     * 
     * @param workIds 需要删除的简历工作经历信息管理主键集合
     * @return 结果
     */
    public int deleteResumeWorkByWorkIds(Long[] workIds);

    /**
     * 删除简历工作经历信息管理信息
     * 
     * @param workId 简历工作经历信息管理主键
     * @return 结果
     */
    public int deleteResumeWorkByWorkId(Long workId);

    /**
     * 根据简历ID删除简历工作履历信息
     *
     * @param resumeId
     * @return
     */
    public int deleteResumeWorkByResumeId(Long resumeId);
}
