package com.ruoyi.system.service.resume.impl;

import java.util.List;

import com.ruoyi.system.domain.resume.CompanyInfo;
import com.ruoyi.system.mapper.resume.CompanyInfoMapper;
import com.ruoyi.system.service.resume.ICompanyInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 公司基本信息管理Service业务层处理
 * 
 * @author ruoyi
 * @date 2024-02-21
 */
@Service
public class CompanyInfoServiceImpl implements ICompanyInfoService
{
    @Autowired
    private CompanyInfoMapper companyInfoMapper;

    /**
     * 查询公司基本信息管理
     * 
     * @param id 公司基本信息管理主键
     * @return 公司基本信息管理
     */
    @Override
    public CompanyInfo selectCompanyInfoById(Long id)
    {
        return companyInfoMapper.selectCompanyInfoById(id);
    }

    /**
     * 查询公司基本信息管理列表
     * 
     * @param companyInfo 公司基本信息管理
     * @return 公司基本信息管理
     */
    @Override
    public List<CompanyInfo> selectCompanyInfoList(CompanyInfo companyInfo)
    {
        return companyInfoMapper.selectCompanyInfoList(companyInfo);
    }

    /**
     * 新增公司基本信息管理
     * 
     * @param companyInfo 公司基本信息管理
     * @return 结果
     */
    @Override
    public int insertCompanyInfo(CompanyInfo companyInfo)
    {
        return companyInfoMapper.insertCompanyInfo(companyInfo);
    }

    /**
     * 修改公司基本信息管理
     * 
     * @param companyInfo 公司基本信息管理
     * @return 结果
     */
    @Override
    public int updateCompanyInfo(CompanyInfo companyInfo)
    {
        return companyInfoMapper.updateCompanyInfo(companyInfo);
    }

    /**
     * 批量删除公司基本信息管理
     * 
     * @param ids 需要删除的公司基本信息管理主键
     * @return 结果
     */
    @Override
    public int deleteCompanyInfoByIds(Long[] ids)
    {
        return companyInfoMapper.deleteCompanyInfoByIds(ids);
    }

    /**
     * 删除公司基本信息管理信息
     * 
     * @param id 公司基本信息管理主键
     * @return 结果
     */
    @Override
    public int deleteCompanyInfoById(Long id)
    {
        return companyInfoMapper.deleteCompanyInfoById(id);
    }
}
