package com.ruoyi.system.service.resume.impl;

import java.util.List;

import com.ruoyi.system.domain.resume.ResumeEducation;
import com.ruoyi.system.mapper.resume.ResumeEducationMapper;
import com.ruoyi.system.service.resume.IResumeEducationService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 简历教育信息管理Service业务层处理
 * 
 * @author ruoyi
 * @date 2024-02-21
 */
@Service
public class ResumeEducationServiceImpl implements IResumeEducationService
{
    @Autowired
    private ResumeEducationMapper resumeEducationMapper;

    /**
     * 查询简历教育信息管理
     * 
     * @param eduId 简历教育信息管理主键
     * @return 简历教育信息管理
     */
    @Override
    public ResumeEducation selectResumeEducationByEduId(Long eduId)
    {
        return resumeEducationMapper.selectResumeEducationByEduId(eduId);
    }

    /**
     * 查询简历教育信息管理列表
     * 
     * @param resumeEducation 简历教育信息管理
     * @return 简历教育信息管理
     */
    @Override
    public List<ResumeEducation> selectResumeEducationList(ResumeEducation resumeEducation)
    {
        return resumeEducationMapper.selectResumeEducationList(resumeEducation);
    }

    /**
     * 新增简历教育信息管理
     * 
     * @param resumeEducation 简历教育信息管理
     * @return 结果
     */
    @Override
    public int insertResumeEducation(ResumeEducation resumeEducation)
    {
        return resumeEducationMapper.insertResumeEducation(resumeEducation);
    }

    /**
     * 修改简历教育信息管理
     * 
     * @param resumeEducation 简历教育信息管理
     * @return 结果
     */
    @Override
    public int updateResumeEducation(ResumeEducation resumeEducation)
    {
        return resumeEducationMapper.updateResumeEducation(resumeEducation);
    }

    /**
     * 批量删除简历教育信息管理
     * 
     * @param eduIds 需要删除的简历教育信息管理主键
     * @return 结果
     */
    @Override
    public int deleteResumeEducationByEduIds(Long[] eduIds)
    {
        return resumeEducationMapper.deleteResumeEducationByEduIds(eduIds);
    }

    /**
     * 删除简历教育信息管理信息
     * 
     * @param eduId 简历教育信息管理主键
     * @return 结果
     */
    @Override
    public int deleteResumeEducationByEduId(Long eduId)
    {
        return resumeEducationMapper.deleteResumeEducationByEduId(eduId);
    }

    /**
     * 根据简历ID删除简历教育信息
     *
     * @param resumeId
     * @return
     */
    @Override
    public int deleteResumeEducationByResumeId(Long resumeId) {
        return resumeEducationMapper.deleteResumeEducationByResumeId(resumeId);
    }
}
