package com.ruoyi.system.service.resume.impl;

import java.util.List;

import com.ruoyi.system.domain.resume.ResumeProject;
import com.ruoyi.system.mapper.resume.ResumeProjectMapper;
import com.ruoyi.system.service.resume.IResumeProjectService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 简历项目信息管理Service业务层处理
 * 
 * @author ruoyi
 * @date 2024-02-21
 */
@Service
public class ResumeProjectServiceImpl implements IResumeProjectService
{
    @Autowired
    private ResumeProjectMapper resumeProjectMapper;

    /**
     * 查询简历项目信息管理
     * 
     * @param projectId 简历项目信息管理主键
     * @return 简历项目信息管理
     */
    @Override
    public ResumeProject selectResumeProjectByProjectId(Long projectId)
    {
        return resumeProjectMapper.selectResumeProjectByProjectId(projectId);
    }

    /**
     * 查询简历项目信息管理列表
     * 
     * @param resumeProject 简历项目信息管理
     * @return 简历项目信息管理
     */
    @Override
    public List<ResumeProject> selectResumeProjectList(ResumeProject resumeProject)
    {
        return resumeProjectMapper.selectResumeProjectList(resumeProject);
    }

    /**
     * 新增简历项目信息管理
     * 
     * @param resumeProject 简历项目信息管理
     * @return 结果
     */
    @Override
    public int insertResumeProject(ResumeProject resumeProject)
    {
        return resumeProjectMapper.insertResumeProject(resumeProject);
    }

    /**
     * 修改简历项目信息管理
     * 
     * @param resumeProject 简历项目信息管理
     * @return 结果
     */
    @Override
    public int updateResumeProject(ResumeProject resumeProject)
    {
        return resumeProjectMapper.updateResumeProject(resumeProject);
    }

    /**
     * 批量删除简历项目信息管理
     * 
     * @param projectIds 需要删除的简历项目信息管理主键
     * @return 结果
     */
    @Override
    public int deleteResumeProjectByProjectIds(Long[] projectIds)
    {
        return resumeProjectMapper.deleteResumeProjectByProjectIds(projectIds);
    }

    /**
     * 删除简历项目信息管理信息
     * 
     * @param projectId 简历项目信息管理主键
     * @return 结果
     */
    @Override
    public int deleteResumeProjectByProjectId(Long projectId)
    {
        return resumeProjectMapper.deleteResumeProjectByProjectId(projectId);
    }

    /**
     * 根据简历ID删除简历项目经验信息
     *
     * @param resumeId
     * @return
     */
    @Override
    public int deleteResumeProjectByResumeId(Long resumeId) {
        return resumeProjectMapper.deleteResumeProjectByResumeId(resumeId);
    }
}
