package com.ruoyi.tool.domain;

import org.apache.commons.lang3.StringUtils;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

/**
 * 企业信息管理对象 t_enterprise_company
 * 
 * @author ruoyi
 * @date 2024-06-03
 */
public class TEnterpriseCompany extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键 */
    private String id;

    /** 企业应用ID */
    @Excel(name = "企业应用ID")
    private String agentid;

    /** 企业应用名称 */
    @Excel(name = "企业应用名称")
    private String name;

    /** 企业应用头像 */
    @Excel(name = "企业应用头像")
    private String logoUrl;

    /** 企业应用描述 */
    @Excel(name = "企业应用描述")
    private String description;

    /** 授权方企业应用是否被禁用： */
    @Excel(name = "授权方企业应用是否被禁用：")
    private String close;

    /** 授权企业的CorpId */
    @Excel(name = "授权企业的CorpId")
    private String corpid;

    /** 邀请码，只有自己邀请的企业才会返回邀请码，可用该邀请码统计不同渠道的拉新，否则值为空字符串 */
    @Excel(name = "邀请码，只有自己邀请的企业才会返回邀请码，可用该邀请码统计不同渠道的拉新，否则值为空字符串")
    private String inviteCode;

    /** 企业所属行业 */
    @Excel(name = "企业所属行业")
    private String industry;

    /** 授权方企业名称 */
    @Excel(name = "授权方企业名称")
    private String corpName;

    /** 序列号 */
    @Excel(name = "序列号")
    private String licenseCode;

    /** 渠道码 */
    @Excel(name = "渠道码")
    private String authChannel;

    /** 渠道类型。 */
    @Excel(name = "渠道类型。")
    private String authChannelType;

    /** 企业是否认证 */
    @Excel(name = "企业是否认证")
    private String isAuthenticated;

    /** 企业认证等级： */
    @Excel(name = "企业认证等级：")
    private String authLevel;

    /** 企业邀请链接 */
    @Excel(name = "企业邀请链接")
    private String inviteUrl;

    /** 企业logo */
    @Excel(name = "企业logo")
    private String corpLogoUrl;

    /** 备注 */
    @Excel(name = "备注")
    private String mark;

    /** 状态 */
    private String delFlag;

    public void setId(String id) 
    {
        this.id = id;
    }

    public String getId() 
    {
        return id;
    }
    public void setAgentid(String agentid) 
    {
        this.agentid = agentid;
    }

    public String getAgentid() 
    {
        return agentid;
    }
    public void setName(String name) 
    {
        this.name = name;
    }

    public String getName() 
    {
        return name;
    }
    public void setLogoUrl(String logoUrl) 
    {
        this.logoUrl = logoUrl;
    }

    public String getLogoUrl() 
    {
        return logoUrl;
    }
    public void setDescription(String description) 
    {
        this.description = description;
    }

    public String getDescription() 
    {
        return description;
    }
    public void setClose(String close) 
    {
        this.close = close;
    }

    public String getClose() 
    {
        return close;
    }
    public void setCorpid(String corpid) 
    {
        this.corpid = corpid;
    }

    public String getCorpid() 
    {
        return corpid;
    }
    public void setInviteCode(String inviteCode) 
    {
        this.inviteCode = inviteCode;
    }

    public String getInviteCode() 
    {
        return inviteCode;
    }
    public void setIndustry(String industry) 
    {
        this.industry = industry;
    }

    public String getIndustry() 
    {
        return industry;
    }
    public void setCorpName(String corpName) 
    {
        this.corpName = corpName;
    }

    public String getCorpName() 
    {
        return corpName;
    }
    public void setLicenseCode(String licenseCode) 
    {
        this.licenseCode = licenseCode;
    }

    public String getLicenseCode() 
    {
        return licenseCode;
    }
    public void setAuthChannel(String authChannel) 
    {
        this.authChannel = authChannel;
    }

    public String getAuthChannel() 
    {
        return authChannel;
    }
    public void setAuthChannelType(String authChannelType) 
    {
        this.authChannelType = authChannelType;
    }

    public String getAuthChannelType() 
    {
        return authChannelType;
    }
    public void setIsAuthenticated(String isAuthenticated) 
    {
        this.isAuthenticated = isAuthenticated;
    }

    public String getIsAuthenticated() 
    {
        return isAuthenticated;
    }
    public void setAuthLevel(String authLevel) 
    {
        this.authLevel = authLevel;
    }

    public String getAuthLevel() 
    {
        return authLevel;
    }
    public void setInviteUrl(String inviteUrl) 
    {
        this.inviteUrl = inviteUrl;
    }

    public String getInviteUrl() 
    {
        return inviteUrl;
    }
    public void setCorpLogoUrl(String corpLogoUrl) 
    {
        this.corpLogoUrl = corpLogoUrl;
    }

    public String getCorpLogoUrl() 
    {
        return corpLogoUrl;
    }
    public void setMark(String mark) 
    {
        this.mark = mark;
    }

    public String getMark() 
    {
        return mark;
    }
    public void setDelFlag(String delFlag) 
    {
        this.delFlag = delFlag;
    }

    public String getDelFlag() 
    {
        return delFlag;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this,ToStringStyle.MULTI_LINE_STYLE)
            .append("id", getId())
            .append("agentid", getAgentid())
            .append("name", getName())
            .append("logoUrl", getLogoUrl())
            .append("description", getDescription())
            .append("close", getClose())
            .append("corpid", getCorpid())
            .append("inviteCode", getInviteCode())
            .append("industry", getIndustry())
            .append("corpName", getCorpName())
            .append("licenseCode", getLicenseCode())
            .append("authChannel", getAuthChannel())
            .append("authChannelType", getAuthChannelType())
            .append("isAuthenticated", getIsAuthenticated())
            .append("authLevel", getAuthLevel())
            .append("inviteUrl", getInviteUrl())
            .append("corpLogoUrl", getCorpLogoUrl())
            .append("mark", getMark())
            .append("delFlag", getDelFlag())
            .append("createBy", getCreateBy())
            .append("createTime", getCreateTime())
            .append("updateBy", getUpdateBy())
            .append("updateTime", getUpdateTime())
            .toString();
    }

    /**
     * 自定义的复制方法，忽略空值
     * @param other
     * @param ignoreNulls
     */
    public void copyFrom(TEnterpriseCompany other, boolean ignoreNulls) {
        if (other == null) {
            throw new IllegalArgumentException("Other object cannot be null");
        }
        if (ignoreNulls) {
            this.setName(other.getName() != null && StringUtils.isNotEmpty(other.getName()) ? other.getName() : this.getName());
            this.setAgentid(other.getAgentid() != null && StringUtils.isNotEmpty(other.getAgentid()) ? other.getAgentid() : this.getAgentid());
            this.setLogoUrl(other.getLogoUrl() != null && StringUtils.isNotEmpty(other.getLogoUrl()) ? other.getLogoUrl() : this.getLogoUrl());
            this.setDescription(other.getDescription() != null && StringUtils.isNotEmpty(other.getDescription()) ? other.getDescription() : this.getDescription());
            this.setClose(other.getClose() != null && StringUtils.isNotEmpty(other.getClose()) ? other.getClose() : this.getClose());
            this.setCorpid(other.getCorpid() != null && StringUtils.isNotEmpty(other.getCorpid()) ? other.getCorpid() : this.getCorpid());
            this.setInviteCode(other.getInviteCode() != null && StringUtils.isNotEmpty(other.getInviteCode()) ? other.getInviteCode() : this.getInviteCode());
            this.setIndustry(other.getIndustry() != null && StringUtils.isNotEmpty(other.getIndustry()) ? other.getIndustry() : this.getIndustry());
            this.setCorpName(other.getCorpName() != null && StringUtils.isNotEmpty(other.getCorpName()) ? other.getCorpName() : this.getCorpName());
            this.setLicenseCode(other.getLicenseCode() != null && StringUtils.isNotEmpty(other.getLicenseCode()) ? other.getLicenseCode() : this.getLicenseCode());
            this.setAuthChannel(other.getAuthChannel() != null && StringUtils.isNotEmpty(other.getAuthChannel()) ? other.getAuthChannel() : this.getAuthChannel());
            this.setAuthChannelType(other.getAuthChannelType() != null && StringUtils.isNotEmpty(other.getAuthChannelType()) ? other.getAuthChannelType() : this.getAuthChannelType());
            this.setIsAuthenticated(other.getIsAuthenticated() != null && StringUtils.isNotEmpty(other.getIsAuthenticated()) ? other.getIsAuthenticated() : this.getIsAuthenticated());
            this.setAuthLevel(other.getAuthLevel() != null && StringUtils.isNotEmpty(other.getAuthLevel()) ? other.getAuthLevel() : this.getAuthLevel());
            this.setInviteUrl(other.getInviteUrl() != null && StringUtils.isNotEmpty(other.getInviteUrl()) ? other.getInviteUrl() : this.getInviteUrl());
            this.setCorpLogoUrl(other.getCorpLogoUrl() != null && StringUtils.isNotEmpty(other.getCorpLogoUrl()) ? other.getCorpLogoUrl() : this.getCorpLogoUrl());


        } else {
            // 如果不忽略空值，则直接复制
            this.setName(other.getName());
            this.setAgentid(other.getAgentid());
            this.setLogoUrl(other.getLogoUrl());
            this.setDescription(other.getDescription());
            this.setClose(other.getClose());
            this.setCorpid(other.getCorpid());
            this.setInviteCode(other.getInviteCode());
            this.setIndustry(other.getIndustry());
            this.setCorpName(other.getCorpName());
            this.setLicenseCode(other.getLicenseCode());
            this.setAuthChannel(other.getAuthChannel());
            this.setAuthChannelType(other.getAuthChannelType());
            this.setIsAuthenticated(other.getIsAuthenticated());
            this.setAuthLevel(other.getAuthLevel());
            this.setInviteUrl(other.getInviteUrl());
            this.setCorpLogoUrl(other.getCorpLogoUrl());
        }
    }

}
