package com.ruoyi.tool.domain;

import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

/**
 * moonshot AI记录对象 t_moonshot_record
 * 
 * @author ruoyi
 * @date 2024-06-06
 */
public class TMoonshotRecord extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键ID */
    private String id;

    /** 企业ID */
    @Excel(name = "企业ID")
    private String corpId;

    /** 用户ID */
    @Excel(name = "用户ID")
    private String userId;

    /** 模型（8、32、128） */
    @Excel(name = "模型", readConverterExp = "8=、32、128")
    private String model;

    /** 聊天完成时生成的最大 token 数。如果到生成了最大 token 数个结果仍然没有结束，finish reason 会是 "length", 否则会是 "stop" */
    @Excel(name = "聊天完成时生成的最大 token 数。如果到生成了最大 token 数个结果仍然没有结束，finish reason 会是 `length`, 否则会是 `stop`")
    private Long maxTokens;

    /** 使用什么采样温度，介于 0 和 1 之间。较高的值（如 0.7）将使输出更加随机，而较低的值（如 0.2）将使其更加集中和确定性 */
    @Excel(name = "使用什么采样温度，介于 0 和 1 之间。较高的值", readConverterExp = "如=,0=.7")
    private String temperature;

    /** 另一种采样方法 */
    @Excel(name = "另一种采样方法")
    private String topP;

    /** 为每条输入消息生成多少个结果 */
    @Excel(name = "为每条输入消息生成多少个结果")
    private Long n;

    /** 存在惩罚 */
    @Excel(name = "存在惩罚")
    private String presencePenalty;

    /** 频率惩罚 */
    @Excel(name = "频率惩罚")
    private String frequencyPenalty;

    /** 停止词 */
    @Excel(name = "停止词")
    private String stop;

    /** 是否流式返回 */
    @Excel(name = "是否流式返回")
    private String stream;

    /** 状态 */
    private String delFlag;

    public void setId(String id) 
    {
        this.id = id;
    }

    public String getId() 
    {
        return id;
    }
    public void setCorpId(String corpId) 
    {
        this.corpId = corpId;
    }

    public String getCorpId() 
    {
        return corpId;
    }
    public void setUserId(String userId) 
    {
        this.userId = userId;
    }

    public String getUserId() 
    {
        return userId;
    }
    public void setModel(String model) 
    {
        this.model = model;
    }

    public String getModel() 
    {
        return model;
    }
    public void setMaxTokens(Long maxTokens) 
    {
        this.maxTokens = maxTokens;
    }

    public Long getMaxTokens() 
    {
        return maxTokens;
    }
    public void setTemperature(String temperature) 
    {
        this.temperature = temperature;
    }

    public String getTemperature() 
    {
        return temperature;
    }
    public void setTopP(String topP) 
    {
        this.topP = topP;
    }

    public String getTopP() 
    {
        return topP;
    }
    public void setN(Long n) 
    {
        this.n = n;
    }

    public Long getN() 
    {
        return n;
    }
    public void setPresencePenalty(String presencePenalty) 
    {
        this.presencePenalty = presencePenalty;
    }

    public String getPresencePenalty() 
    {
        return presencePenalty;
    }
    public void setFrequencyPenalty(String frequencyPenalty) 
    {
        this.frequencyPenalty = frequencyPenalty;
    }

    public String getFrequencyPenalty() 
    {
        return frequencyPenalty;
    }
    public void setStop(String stop) 
    {
        this.stop = stop;
    }

    public String getStop() 
    {
        return stop;
    }
    public void setStream(String stream) 
    {
        this.stream = stream;
    }

    public String getStream() 
    {
        return stream;
    }
    public void setDelFlag(String delFlag) 
    {
        this.delFlag = delFlag;
    }

    public String getDelFlag() 
    {
        return delFlag;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this,ToStringStyle.MULTI_LINE_STYLE)
            .append("id", getId())
            .append("corpId", getCorpId())
            .append("userId", getUserId())
            .append("model", getModel())
            .append("maxTokens", getMaxTokens())
            .append("temperature", getTemperature())
            .append("topP", getTopP())
            .append("n", getN())
            .append("presencePenalty", getPresencePenalty())
            .append("frequencyPenalty", getFrequencyPenalty())
            .append("stop", getStop())
            .append("stream", getStream())
            .append("delFlag", getDelFlag())
            .append("createBy", getCreateBy())
            .append("createTime", getCreateTime())
            .append("updateBy", getUpdateBy())
            .append("updateTime", getUpdateTime())
            .toString();
    }
}
