package com.ruoyi.tool.mapper;

import java.util.List;
import com.ruoyi.tool.domain.TEnterpriseCompany;
import org.apache.ibatis.annotations.Param;

/**
 * 企业信息管理Mapper接口
 * 
 * @author ruoyi
 * @date 2024-06-03
 */
public interface TEnterpriseCompanyMapper 
{
    /**
     * 查询企业信息管理
     * 
     * @param id 企业信息管理主键
     * @return 企业信息管理
     */
    public TEnterpriseCompany selectTEnterpriseCompanyById(String id);

    /**
     * 查询企业信息管理列表
     * 
     * @param tEnterpriseCompany 企业信息管理
     * @return 企业信息管理集合
     */
    public List<TEnterpriseCompany> selectTEnterpriseCompanyList(TEnterpriseCompany tEnterpriseCompany);

    /**
     * 新增企业信息管理
     * 
     * @param tEnterpriseCompany 企业信息管理
     * @return 结果
     */
    public int insertTEnterpriseCompany(TEnterpriseCompany tEnterpriseCompany);

    /**
     * 修改企业信息管理
     * 
     * @param tEnterpriseCompany 企业信息管理
     * @return 结果
     */
    public int updateTEnterpriseCompany(TEnterpriseCompany tEnterpriseCompany);

    /**
     * 删除企业信息管理
     * 
     * @param id 企业信息管理主键
     * @return 结果
     */
    public int deleteTEnterpriseCompanyById(String id);

    /**
     * 批量删除企业信息管理
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTEnterpriseCompanyByIds(String[] ids);

    /**
     * 根据企业ID查询数据
     * @param corpid
     * @return
     */
    TEnterpriseCompany selectTEnterpriseCompanyByCorpId(@Param("corpid") String corpid);

    /**
     * 解除授权企业
     * @param corpid
     */
    int updateTCompanyUserClose(@Param("corpid") String corpid);
}
