package com.ruoyi.tool.mapper;

import java.util.List;
import com.ruoyi.tool.domain.TMoonshotRecordInfo;

/**
 * moonshot AI记录详情Mapper接口
 * 
 * @author ruoyi
 * @date 2024-06-06
 */
public interface TMoonshotRecordInfoMapper 
{
    /**
     * 查询moonshot AI记录详情
     * 
     * @param id moonshot AI记录详情主键
     * @return moonshot AI记录详情
     */
    public TMoonshotRecordInfo selectTMoonshotRecordInfoById(String id);

    /**
     * 查询moonshot AI记录详情列表
     * 
     * @param tMoonshotRecordInfo moonshot AI记录详情
     * @return moonshot AI记录详情集合
     */
    public List<TMoonshotRecordInfo> selectTMoonshotRecordInfoList(TMoonshotRecordInfo tMoonshotRecordInfo);

    /**
     * 新增moonshot AI记录详情
     * 
     * @param tMoonshotRecordInfo moonshot AI记录详情
     * @return 结果
     */
    public int insertTMoonshotRecordInfo(TMoonshotRecordInfo tMoonshotRecordInfo);

    /**
     * 修改moonshot AI记录详情
     * 
     * @param tMoonshotRecordInfo moonshot AI记录详情
     * @return 结果
     */
    public int updateTMoonshotRecordInfo(TMoonshotRecordInfo tMoonshotRecordInfo);

    /**
     * 删除moonshot AI记录详情
     * 
     * @param id moonshot AI记录详情主键
     * @return 结果
     */
    public int deleteTMoonshotRecordInfoById(String id);

    /**
     * 批量删除moonshot AI记录详情
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTMoonshotRecordInfoByIds(String[] ids);
}
