package com.ruoyi.tool.service;

import java.util.List;
import com.ruoyi.tool.domain.TCompanyUser;

/**
 * 企业管理员Service接口
 * 
 * @author ruoyi
 * @date 2024-06-04
 */
public interface ITCompanyUserService 
{
    /**
     * 查询企业管理员
     * 
     * @param id 企业管理员主键
     * @return 企业管理员
     */
    public TCompanyUser selectTCompanyUserById(String id);

    /**
     * 查询企业管理员列表
     * 
     * @param tCompanyUser 企业管理员
     * @return 企业管理员集合
     */
    public List<TCompanyUser> selectTCompanyUserList(TCompanyUser tCompanyUser);

    /**
     * 新增企业管理员
     * 
     * @param tCompanyUser 企业管理员
     * @return 结果
     */
    public int insertTCompanyUser(TCompanyUser tCompanyUser);

    /**
     * 修改企业管理员
     * 
     * @param tCompanyUser 企业管理员
     * @return 结果
     */
    public int updateTCompanyUser(TCompanyUser tCompanyUser);

    /**
     * 批量删除企业管理员
     * 
     * @param ids 需要删除的企业管理员主键集合
     * @return 结果
     */
    public int deleteTCompanyUserByIds(String[] ids);

    /**
     * 删除企业管理员信息
     * 
     * @param id 企业管理员主键
     * @return 结果
     */
    public int deleteTCompanyUserById(String id);



}
