package com.ruoyi.tool.service;

import java.util.List;
import com.ruoyi.tool.domain.TEnterpriseCompany;

/**
 * 企业信息管理Service接口
 * 
 * @author ruoyi
 * @date 2024-06-03
 */
public interface ITEnterpriseCompanyService 
{
    /**
     * 查询企业信息管理
     * 
     * @param id 企业信息管理主键
     * @return 企业信息管理
     */
    public TEnterpriseCompany selectTEnterpriseCompanyById(String id);

    /**
     * 查询企业信息管理列表
     * 
     * @param tEnterpriseCompany 企业信息管理
     * @return 企业信息管理集合
     */
    public List<TEnterpriseCompany> selectTEnterpriseCompanyList(TEnterpriseCompany tEnterpriseCompany);

    /**
     * 新增企业信息管理
     * 
     * @param tEnterpriseCompany 企业信息管理
     * @return 结果
     */
    public int insertTEnterpriseCompany(TEnterpriseCompany tEnterpriseCompany);

    /**
     * 修改企业信息管理
     * 
     * @param tEnterpriseCompany 企业信息管理
     * @return 结果
     */
    public int updateTEnterpriseCompany(TEnterpriseCompany tEnterpriseCompany);

    /**
     * 批量删除企业信息管理
     * 
     * @param ids 需要删除的企业信息管理主键集合
     * @return 结果
     */
    public int deleteTEnterpriseCompanyByIds(String[] ids);

    /**
     * 删除企业信息管理信息
     * 
     * @param id 企业信息管理主键
     * @return 结果
     */
    public int deleteTEnterpriseCompanyById(String id);

    /**
     * 根据企业ID查询数据
     * @param corpid
     * @return
     */
    TEnterpriseCompany selectTEnterpriseCompanyByCorpId(String corpid);

    /**
     * 解除授权方企业信息
     * @param corpId
     */
    int updateTCompanyUserClose(String corpId);
}
