package com.ruoyi.tool.service;

import java.util.List;
import com.ruoyi.tool.domain.TMoonshotRecordFile;

/**
 * moonshot关联简历附件Service接口
 * 
 * @author ruoyi
 * @date 2024-06-06
 */
public interface ITMoonshotRecordFileService 
{
    /**
     * 查询moonshot关联简历附件
     * 
     * @param corpId moonshot关联简历附件主键
     * @return moonshot关联简历附件
     */
    public TMoonshotRecordFile selectTMoonshotRecordFileByCorpId(String corpId);

    /**
     * 查询moonshot关联简历附件列表
     * 
     * @param tMoonshotRecordFile moonshot关联简历附件
     * @return moonshot关联简历附件集合
     */
    public List<TMoonshotRecordFile> selectTMoonshotRecordFileList(TMoonshotRecordFile tMoonshotRecordFile);

    /**
     * 新增moonshot关联简历附件
     * 
     * @param tMoonshotRecordFile moonshot关联简历附件
     * @return 结果
     */
    public int insertTMoonshotRecordFile(TMoonshotRecordFile tMoonshotRecordFile);

    /**
     * 修改moonshot关联简历附件
     * 
     * @param tMoonshotRecordFile moonshot关联简历附件
     * @return 结果
     */
    public int updateTMoonshotRecordFile(TMoonshotRecordFile tMoonshotRecordFile);

    /**
     * 批量删除moonshot关联简历附件
     * 
     * @param corpIds 需要删除的moonshot关联简历附件主键集合
     * @return 结果
     */
    public int deleteTMoonshotRecordFileByCorpIds(String[] corpIds);

    /**
     * 删除moonshot关联简历附件信息
     * 
     * @param corpId moonshot关联简历附件主键
     * @return 结果
     */
    public int deleteTMoonshotRecordFileByCorpId(String corpId);
}
