package com.ruoyi.tool.service;

import java.util.List;
import com.ruoyi.tool.domain.TMoonshotRecord;

/**
 * moonshot AI记录Service接口
 * 
 * @author ruoyi
 * @date 2024-06-06
 */
public interface ITMoonshotRecordService 
{
    /**
     * 查询moonshot AI记录
     * 
     * @param id moonshot AI记录主键
     * @return moonshot AI记录
     */
    public TMoonshotRecord selectTMoonshotRecordById(String id);

    /**
     * 查询moonshot AI记录列表
     * 
     * @param tMoonshotRecord moonshot AI记录
     * @return moonshot AI记录集合
     */
    public List<TMoonshotRecord> selectTMoonshotRecordList(TMoonshotRecord tMoonshotRecord);

    /**
     * 新增moonshot AI记录
     * 
     * @param tMoonshotRecord moonshot AI记录
     * @return 结果
     */
    public int insertTMoonshotRecord(TMoonshotRecord tMoonshotRecord);

    /**
     * 修改moonshot AI记录
     * 
     * @param tMoonshotRecord moonshot AI记录
     * @return 结果
     */
    public int updateTMoonshotRecord(TMoonshotRecord tMoonshotRecord);

    /**
     * 批量删除moonshot AI记录
     * 
     * @param ids 需要删除的moonshot AI记录主键集合
     * @return 结果
     */
    public int deleteTMoonshotRecordByIds(String[] ids);

    /**
     * 删除moonshot AI记录信息
     * 
     * @param id moonshot AI记录主键
     * @return 结果
     */
    public int deleteTMoonshotRecordById(String id);
}
