package com.ruoyi.tool.service.impl;

import com.ruoyi.common.core.domain.entity.SysUser;
import com.ruoyi.tool.domain.AuthApply;
import com.ruoyi.tool.mapper.AuthApplyMapper;
import com.ruoyi.tool.service.IAuthApplyService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;

/**
 * @author hanzy
 * @description
 * @date 2024年06月06日 13:16
 */
@Service
public class AuthApplyServiceImpl implements IAuthApplyService {
    @Resource
    private AuthApplyMapper authApplyMapper;

    @Override
    public void applyAuth(SysUser sysUser) {
        AuthApply authApply = new AuthApply();
        authApply.setApplicant(sysUser.getUserName());
        authApply.setStatus(0);
        authApply.setCorpId(sysUser.getCorpId());
        authApply.setCreateBy(sysUser.getUserId().toString());
        authApply.setCreateTime(new Date());
        authApplyMapper.insertSelective(authApply);
    }

    @Override
    public void applyComplete(Long id, Boolean flag, Long userId) {
        AuthApply authApply = new AuthApply();
        authApply.setId(id);
        authApply.setStatus(flag ? 1 : 2);
        authApply.setUpdateBy(userId.toString());
        authApply.setUpdateTime(new Date());
        authApplyMapper.updateByPrimaryKeySelective(authApply);
    }

    @Override
    public List<AuthApply> applyAuthList(int status, String corpId) {
        return authApplyMapper.selectByStatusAndCorpId(status, corpId);
    }
}
