package com.ruoyi.tool.service.impl;

import java.util.List;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.uuid.IdUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.tool.mapper.TCompanyUserMapper;
import com.ruoyi.tool.domain.TCompanyUser;
import com.ruoyi.tool.service.ITCompanyUserService;

/**
 * 企业管理员Service业务层处理
 * 
 * @author ruoyi
 * @date 2024-06-04
 */
@Service
public class TCompanyUserServiceImpl implements ITCompanyUserService
{
    @Autowired
    private TCompanyUserMapper tCompanyUserMapper;

    /**
     * 查询企业管理员
     * 
     * @param id 企业管理员主键
     * @return 企业管理员
     */
    @Override
    public TCompanyUser selectTCompanyUserById(String id)
    {
        return tCompanyUserMapper.selectTCompanyUserById(id);
    }

    /**
     * 查询企业管理员列表
     * 
     * @param tCompanyUser 企业管理员
     * @return 企业管理员
     */
    @Override
    public List<TCompanyUser> selectTCompanyUserList(TCompanyUser tCompanyUser)
    {
        return tCompanyUserMapper.selectTCompanyUserList(tCompanyUser);
    }

    /**
     * 新增企业管理员
     * 
     * @param tCompanyUser 企业管理员
     * @return 结果
     */
    @Override
    public int insertTCompanyUser(TCompanyUser tCompanyUser)
    {
        tCompanyUser.setId(IdUtils.fastSimpleUUID());
        tCompanyUser.setCreateTime(DateUtils.getNowDate());
        return tCompanyUserMapper.insertTCompanyUser(tCompanyUser);
    }

    /**
     * 修改企业管理员
     * 
     * @param tCompanyUser 企业管理员
     * @return 结果
     */
    @Override
    public int updateTCompanyUser(TCompanyUser tCompanyUser)
    {
        tCompanyUser.setUpdateTime(DateUtils.getNowDate());
        return tCompanyUserMapper.updateTCompanyUser(tCompanyUser);
    }

    /**
     * 批量删除企业管理员
     * 
     * @param ids 需要删除的企业管理员主键
     * @return 结果
     */
    @Override
    public int deleteTCompanyUserByIds(String[] ids)
    {
        return tCompanyUserMapper.deleteTCompanyUserByIds(ids);
    }

    /**
     * 删除企业管理员信息
     * 
     * @param id 企业管理员主键
     * @return 结果
     */
    @Override
    public int deleteTCompanyUserById(String id)
    {
        return tCompanyUserMapper.deleteTCompanyUserById(id);
    }

}
