package com.ruoyi.tool.service.impl;

import java.util.List;
import com.ruoyi.common.utils.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.tool.mapper.TMoonshotRecordFileMapper;
import com.ruoyi.tool.domain.TMoonshotRecordFile;
import com.ruoyi.tool.service.ITMoonshotRecordFileService;

/**
 * moonshot关联简历附件Service业务层处理
 * 
 * @author ruoyi
 * @date 2024-06-06
 */
@Service
public class TMoonshotRecordFileServiceImpl implements ITMoonshotRecordFileService 
{
    @Autowired
    private TMoonshotRecordFileMapper tMoonshotRecordFileMapper;

    /**
     * 查询moonshot关联简历附件
     * 
     * @param corpId moonshot关联简历附件主键
     * @return moonshot关联简历附件
     */
    @Override
    public TMoonshotRecordFile selectTMoonshotRecordFileByCorpId(String corpId)
    {
        return tMoonshotRecordFileMapper.selectTMoonshotRecordFileByCorpId(corpId);
    }

    /**
     * 查询moonshot关联简历附件列表
     * 
     * @param tMoonshotRecordFile moonshot关联简历附件
     * @return moonshot关联简历附件
     */
    @Override
    public List<TMoonshotRecordFile> selectTMoonshotRecordFileList(TMoonshotRecordFile tMoonshotRecordFile)
    {
        return tMoonshotRecordFileMapper.selectTMoonshotRecordFileList(tMoonshotRecordFile);
    }

    /**
     * 新增moonshot关联简历附件
     * 
     * @param tMoonshotRecordFile moonshot关联简历附件
     * @return 结果
     */
    @Override
    public int insertTMoonshotRecordFile(TMoonshotRecordFile tMoonshotRecordFile)
    {
        tMoonshotRecordFile.setCreateTime(DateUtils.getNowDate());
        return tMoonshotRecordFileMapper.insertTMoonshotRecordFile(tMoonshotRecordFile);
    }

    /**
     * 修改moonshot关联简历附件
     * 
     * @param tMoonshotRecordFile moonshot关联简历附件
     * @return 结果
     */
    @Override
    public int updateTMoonshotRecordFile(TMoonshotRecordFile tMoonshotRecordFile)
    {
        return tMoonshotRecordFileMapper.updateTMoonshotRecordFile(tMoonshotRecordFile);
    }

    /**
     * 批量删除moonshot关联简历附件
     * 
     * @param corpIds 需要删除的moonshot关联简历附件主键
     * @return 结果
     */
    @Override
    public int deleteTMoonshotRecordFileByCorpIds(String[] corpIds)
    {
        return tMoonshotRecordFileMapper.deleteTMoonshotRecordFileByCorpIds(corpIds);
    }

    /**
     * 删除moonshot关联简历附件信息
     * 
     * @param corpId moonshot关联简历附件主键
     * @return 结果
     */
    @Override
    public int deleteTMoonshotRecordFileByCorpId(String corpId)
    {
        return tMoonshotRecordFileMapper.deleteTMoonshotRecordFileByCorpId(corpId);
    }
}
