package com.ruoyi.tool.service.impl;

import java.util.List;
import com.ruoyi.common.utils.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.tool.mapper.TMoonshotRecordInfoMapper;
import com.ruoyi.tool.domain.TMoonshotRecordInfo;
import com.ruoyi.tool.service.ITMoonshotRecordInfoService;

/**
 * moonshot AI记录详情Service业务层处理
 * 
 * @author ruoyi
 * @date 2024-06-06
 */
@Service
public class TMoonshotRecordInfoServiceImpl implements ITMoonshotRecordInfoService 
{
    @Autowired
    private TMoonshotRecordInfoMapper tMoonshotRecordInfoMapper;

    /**
     * 查询moonshot AI记录详情
     * 
     * @param id moonshot AI记录详情主键
     * @return moonshot AI记录详情
     */
    @Override
    public TMoonshotRecordInfo selectTMoonshotRecordInfoById(String id)
    {
        return tMoonshotRecordInfoMapper.selectTMoonshotRecordInfoById(id);
    }

    /**
     * 查询moonshot AI记录详情列表
     * 
     * @param tMoonshotRecordInfo moonshot AI记录详情
     * @return moonshot AI记录详情
     */
    @Override
    public List<TMoonshotRecordInfo> selectTMoonshotRecordInfoList(TMoonshotRecordInfo tMoonshotRecordInfo)
    {
        return tMoonshotRecordInfoMapper.selectTMoonshotRecordInfoList(tMoonshotRecordInfo);
    }

    /**
     * 新增moonshot AI记录详情
     * 
     * @param tMoonshotRecordInfo moonshot AI记录详情
     * @return 结果
     */
    @Override
    public int insertTMoonshotRecordInfo(TMoonshotRecordInfo tMoonshotRecordInfo)
    {
        tMoonshotRecordInfo.setCreateTime(DateUtils.getNowDate());
        return tMoonshotRecordInfoMapper.insertTMoonshotRecordInfo(tMoonshotRecordInfo);
    }

    /**
     * 修改moonshot AI记录详情
     * 
     * @param tMoonshotRecordInfo moonshot AI记录详情
     * @return 结果
     */
    @Override
    public int updateTMoonshotRecordInfo(TMoonshotRecordInfo tMoonshotRecordInfo)
    {
        tMoonshotRecordInfo.setUpdateTime(DateUtils.getNowDate());
        return tMoonshotRecordInfoMapper.updateTMoonshotRecordInfo(tMoonshotRecordInfo);
    }

    /**
     * 批量删除moonshot AI记录详情
     * 
     * @param ids 需要删除的moonshot AI记录详情主键
     * @return 结果
     */
    @Override
    public int deleteTMoonshotRecordInfoByIds(String[] ids)
    {
        return tMoonshotRecordInfoMapper.deleteTMoonshotRecordInfoByIds(ids);
    }

    /**
     * 删除moonshot AI记录详情信息
     * 
     * @param id moonshot AI记录详情主键
     * @return 结果
     */
    @Override
    public int deleteTMoonshotRecordInfoById(String id)
    {
        return tMoonshotRecordInfoMapper.deleteTMoonshotRecordInfoById(id);
    }
}
