package com.ruoyi.tool.service.impl;

import java.util.List;
import com.ruoyi.common.utils.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.tool.mapper.TMoonshotRecordMapper;
import com.ruoyi.tool.domain.TMoonshotRecord;
import com.ruoyi.tool.service.ITMoonshotRecordService;

/**
 * moonshot AI记录Service业务层处理
 * 
 * @author ruoyi
 * @date 2024-06-06
 */
@Service
public class TMoonshotRecordServiceImpl implements ITMoonshotRecordService 
{
    @Autowired
    private TMoonshotRecordMapper tMoonshotRecordMapper;

    /**
     * 查询moonshot AI记录
     * 
     * @param id moonshot AI记录主键
     * @return moonshot AI记录
     */
    @Override
    public TMoonshotRecord selectTMoonshotRecordById(String id)
    {
        return tMoonshotRecordMapper.selectTMoonshotRecordById(id);
    }

    /**
     * 查询moonshot AI记录列表
     * 
     * @param tMoonshotRecord moonshot AI记录
     * @return moonshot AI记录
     */
    @Override
    public List<TMoonshotRecord> selectTMoonshotRecordList(TMoonshotRecord tMoonshotRecord)
    {
        return tMoonshotRecordMapper.selectTMoonshotRecordList(tMoonshotRecord);
    }

    /**
     * 新增moonshot AI记录
     * 
     * @param tMoonshotRecord moonshot AI记录
     * @return 结果
     */
    @Override
    public int insertTMoonshotRecord(TMoonshotRecord tMoonshotRecord)
    {
        tMoonshotRecord.setCreateTime(DateUtils.getNowDate());
        return tMoonshotRecordMapper.insertTMoonshotRecord(tMoonshotRecord);
    }

    /**
     * 修改moonshot AI记录
     * 
     * @param tMoonshotRecord moonshot AI记录
     * @return 结果
     */
    @Override
    public int updateTMoonshotRecord(TMoonshotRecord tMoonshotRecord)
    {
        tMoonshotRecord.setUpdateTime(DateUtils.getNowDate());
        return tMoonshotRecordMapper.updateTMoonshotRecord(tMoonshotRecord);
    }

    /**
     * 批量删除moonshot AI记录
     * 
     * @param ids 需要删除的moonshot AI记录主键
     * @return 结果
     */
    @Override
    public int deleteTMoonshotRecordByIds(String[] ids)
    {
        return tMoonshotRecordMapper.deleteTMoonshotRecordByIds(ids);
    }

    /**
     * 删除moonshot AI记录信息
     * 
     * @param id moonshot AI记录主键
     * @return 结果
     */
    @Override
    public int deleteTMoonshotRecordById(String id)
    {
        return tMoonshotRecordMapper.deleteTMoonshotRecordById(id);
    }
}
