import request from '@/utils/request'

// 查询企业信息管理列表
export function listCompany(query) {
  return request({
    url: '/tool/company/list',
    method: 'get',
    params: query
  })
}

// 查询企业信息管理详细
export function getCompany(id) {
  return request({
    url: '/tool/company/' + id,
    method: 'get'
  })
}

// 新增企业信息管理
export function addCompany(data) {
  return request({
    url: '/tool/company',
    method: 'post',
    data: data
  })
}

// 修改企业信息管理
export function updateCompany(data) {
  return request({
    url: '/tool/company',
    method: 'put',
    data: data
  })
}

// 删除企业信息管理
export function delCompany(id) {
  return request({
    url: '/tool/company/' + id,
    method: 'delete'
  })
}
